# opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe Class Reference

A key-frame contains:

- an image, and its filtered version (for NCC matching)
- the annotated pose of the visible target (NOTE: only one target per keyframe!)
- the detected (and back-projected) Harris keypoints.

More...

List of all members.

## Public Member Functions
HarrisKeyframe * | clone () const
| HarrisKeyframe (const HarrisKeyframe &c)
| Copy constructor of Harris keyframe.
| HarrisKeyframe (const boost::shared_ptr< opentl::models::Target > &target, opentl::modelprojection::WarpBack *warpBack, modalities::HarrisKeypoints *parentHarrisModality, opentl::core::cvdata::Image *img=NULL)
| Constructor of Harris keyframe, from a set of targets.
void | initKeyFrame ()
| Initialize data for this keyframe: Detect Harris keypoints for the target from a single camera view (considering also mutual occlusions) Back-project them to object space using the depth map.
| ~HarrisKeyframe ()
| Destructor.
## Public Attributes
int | mCamIdx
| Camera ID of this keyframe.
opentl::core::cvdata::Image * | mFilt
| Filtered version (for NCC matching).
opentl::core::cvdata::Image * | mImg
| Keyframe original image.
opentl::core::cvdata::HarrisKeypoints * | mKeypoints
| Keypoints detected on it.
opentl::core::cvdata::Image * | mMaskG
| Keyframe shadow mask.
modalities::HarrisKeypoints * | mParentHarrisModality
| Pointer to the parent modality that created it.
boost::shared_ptr < opentl::models::Target > | mTarget
| Keyframe-associated target.
opentl::modelprojection::WarpBack * | mWarpBack
| Warp pointer.

## Detailed Description

A key-frame contains:

- an image, and its filtered version (for NCC matching)
- the annotated pose of the visible target (NOTE: only one target per keyframe!)
- the detected (and back-projected) Harris keypoints.

## Constructor & Destructor Documentation

opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::HarrisKeyframe | ( | const boost::shared_ptr< opentl::models::Target > & | target,
|  | opentl::modelprojection::WarpBack * | warpBack,
|  | modalities::HarrisKeypoints * | parentHarrisModality,
|  | opentl::core::cvdata::Image * | img = `NULL` |
| ) |  |  |

Constructor of Harris keyframe, from a set of targets.

opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::HarrisKeyframe | ( | const HarrisKeyframe & | c | ) |

Copy constructor of Harris keyframe.

opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::~HarrisKeyframe | ( |  | ) |

Destructor.

## Member Function Documentation

HarrisKeyframe* opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::clone | ( |  | ) | const`[inline]`

void opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::initKeyFrame | ( |  | ) |

Initialize data for this keyframe:

- Detect Harris keypoints for the target from a single camera view (considering also mutual occlusions)
- Back-project them to object space using the depth map.

Parameters:

  | target | Target

## Member Data Documentation

int opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::mCamIdx

Camera ID of this keyframe.

opentl::core::cvdata::Image* opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::mFilt

Filtered version (for NCC matching).

opentl::core::cvdata::Image* opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::mImg

Keyframe original image.

opentl::core::cvdata::HarrisKeypoints* opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::mKeypoints

Keypoints detected on it.

opentl::core::cvdata::Image* opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::mMaskG

Keyframe shadow mask.

modalities::HarrisKeypoints* opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::mParentHarrisModality

Pointer to the parent modality that created it.

boost::shared_ptr<opentl::models::Target> opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::mTarget

Keyframe-associated target.

opentl::modelprojection::WarpBack* opentl::modalities::HarrisKeypoints::HarrisKeypoints::HarrisKeyframe::mWarpBack

Warp pointer.